#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STR 101

typedef struct node
{
  char * name;
  struct node * next;
} Node;
typedef Node * List;

/* inserisce elem. in coda */
List accoda (List l, char * str)
{
  List new = malloc(sizeof(Node));
  new->name = malloc(STR * sizeof(char));
  strncpy(new->name, str, STR);
  new->next = NULL;
  
  List p = l;

  if ( l == NULL ) /* primo paziente */
	return new;
  else {
    while ( p->next != NULL ) {
      p = p->next;
    }
    p->next = new;
    return l;
  }
}

/* rimuove primo el. dalla coda */
List visita (List l)
{
  List temp = l;
  
  l = l->next;

  free(temp->name);
  free(temp);

  return l;
}

int comp (const void * a, const void * b)
{
  List x = *(List *)a;
  List y = *(List *)b;
  return strcmp(x->name, y->name);
}

/* stampa in ordine alfabetico */
void stampa (List l)
{
  List * v;
  List p = l;
  int dim=0, i;

  /* calcolo lung lista */
  while ( p != NULL ) {
    dim++;
    p = p->next;
  }

  if ( dim > 0 ) {

    v = malloc(dim * sizeof(List));

    i=0;
    p = l;
    while ( p != NULL ) {
      v[i] = p;
      p = p->next;
      i++;
    }

    qsort(v, dim, sizeof(List), comp);

    for ( i = 0; i < dim; i++ ) {
      printf("%s\n", v[i]->name);
    }
  }
  printf("$\n");
}

void dealloca(List l)
{
  List t;
  
  while ( l != NULL )
  {
    t = l;
    l = l->next;
    free(t->name);
    free(t);
  }
}


int main ()
{
  List l = NULL;
  int e;

  char * str = malloc(STR * sizeof(char));

  while ( 1 ) {
    scanf("%d", &e);
    if ( e == 0 ) {
      stampa(l);
      break;
    } else if ( e == 1 ) {
      scanf("%s", str);
      l = accoda(l, str);
    } else if ( e == 2 ) {
      l = visita(l);
    }
  }

  dealloca(l);

  return 0;
}
